# Kubernetes

***अपडेट: यदि आप Roboflow Enterprise Customer हैं, तो आप Roboflow Inference Service को अपने Kubernetes environments में इसका उपयोग करके deploy कर सकते हैं*** [***इस Helm chart***](https://github.com/roboflow/inference/tree/main/inference/enterprise/helm-chart)***.***

वैकल्पिक रूप से, Kubernetes cluster में एक pod और service deploy करने के लिए यहाँ सरल Kubernetes manifests दिए गए हैं।

नीचे दिया गया Kubernetes manifest एक single CPU-based roboflow infer pod बनाने और उससे एक cluster-IP service attach करने का एक सरल उदाहरण दिखाता है।

```yaml
# Pod
---
apiVersion: v1
kind: Pod
metadata:
  name: roboflow
  labels:
    app.kubernetes.io/name: roboflow
spec:
  containers:
  - name: roboflow
    image: roboflow/roboflow-inference-server-cpu
    ports:
    - containerPort: 9001
      name: rf-pod-port


# Service
---
apiVersion: v1
kind: Service
metadata:
  name: rf-service
spec:
  type: ClusterIP
  selector:
    app.kubernetes.io/name: roboflow
  ports:
  - name: rf-svc-port
    protocol: TCP
    port: 9001
    targetPort: rf-pod-port
```

(ऊपर दिया गया उदाहरण मानता है कि आपका Kubernetes cluster Docker hub से images डाउनलोड कर सकता है)

ऊपर दिए गए yaml विवरण को इस रूप में सेव करें `roboflow.yaml` और इसका उपयोग करें `kubectl` cli का उपयोग करके pod और service को अपने Kubernetes cluster के default namespace में deploy करें।

```
kubectl apply -f roboflow.yaml
```

\
एक service (ClusterIP प्रकार की) बनाई जाएगी; आप Kubernetes cluster के भीतर इस URI पर Roboflow inference का उपयोग कर सकते हैं: `http://rf-service.default.svc:9001`

### इस उदाहरण से आगे

Kubernetes आपको अपने Roboflow inference service में कई advanced features और extensions शामिल करने की शक्ति देता है। उदाहरण के लिए, आप ऊपर दिए गए उदाहरण को ऐसे अधिक advanced use-cases के लिए बढ़ा सकते हैं जैसे

* nodeSelectors का उपयोग करके pod(s) को अपने Kubernetes environments के भीतर GPU machines node pools पर host करना और इसका उपयोग करना `roboflow/inference-server:gpu` image
* Roboflow inference service को horizontally autoscale करने के लिए Kubernetes deployments बनाना और CPU usage जैसी विशिष्ट metrics के आधार पर auto-scaling triggers सेट करना।
* Roboflow inference service को externally serve करने के लिए nodePort और LoadBalancer जैसे अलग-अलग service types का उपयोग करना
* TLS (HTTPs) आदि पर Roboflow inference को expose करने के लिए ingress controllers का उपयोग करें।
* अपने Roboflow inference service में monitoring और alerting जोड़ें
* license server और offline modes को integrate करना


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.roboflow.com/roboflow/roboflow-hi/deploy/enterprise-deployment/kubernetes.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
